import java.util.ArrayList;

public class MyArrayList<E> {

    private int size;     // number of elements
    private Object[] elements;
    private Object[] tempArray;

    public MyArrayList() {         // constructor
        elements = new Object[0];  // allocate initial capacity of 0
        size = 0;
    }

    public MyArrayList(int num) {
        elements = new Object[num];  // allocate initial capacity of num
        size = 0;
    }

    public void add(E e) {
        if (size < elements.length) {
            elements[size] = e;
        } else {
            tempArray = new Object[elements.length + 1];
            for (int i = 0; i < elements.length; i++) {
                tempArray[i] = elements[i];
            }
            tempArray[tempArray.length - 1] = e;
            elements = tempArray;
        }
        size++;
    }

    public boolean contains(E e) {
        boolean returnThis = false;
        for (Object object : elements) {
            if (object.equals(e)) {
                returnThis = true;
            }
        }
        return returnThis;
    }

    public E get(int index) {
        if (index >= size)
            throw new IndexOutOfBoundsException("Index: " + index + ", Size: " + size);
        return (E) elements[index];
    }

    public int size() {
        return size;
    }

    public void clear() {
        elements = new Object[0];
        size = 0;
    }

    public boolean isEmpty() {
        if (elements.length == 0) {
            return true;
        } else return false;
    }

    public void remove(E e) {
        tempArray = new Object[elements.length - 1];
        int j = 0;
        for (int i = 0; i < elements.length; i++) {
            if (elements[i] != e) {
                tempArray[j] = elements[i];
                j++;
            }
        }
        elements = tempArray;
        size--;
    }

    public void set(int index, E e) {
        elements[index] = e;


    }

}



