import org.junit.Test;

import static org.junit.Assert.assertTrue;

public class MyArrayListTest {

    @Test
    public void addAndContainsTest(){
        MyArrayList<Integer> test = new MyArrayList<>();
        test.add(5);
        assertTrue(test.contains(5));
    }

    @Test
    public void getTest(){
        MyArrayList<Integer> test = new MyArrayList<>();
        test.add(5);
        test.add(6);
        test.add(7);
        test.add(8);

        assertTrue(test.get(2).equals(7));
    }

    @Test
    public void sizeTest(){
        MyArrayList<Integer> test = new MyArrayList<>();
        test.add(5);
        test.add(6);
        test.add(7);
        test.add(8);

        assertTrue(test.size() == 4);
    }

    @Test
    public void clearTest(){
        MyArrayList<Integer> test = new MyArrayList<>();
        test.add(5);
        test.add(6);
        test.add(7);
        test.add(8);
        test.clear();

        assertTrue(test.size() == 0);
    }

    @Test
    public void isEmptyTest(){
        MyArrayList<Integer> test = new MyArrayList<>();
        assertTrue(test.isEmpty());
    }

    @Test
    public void removeTest(){
        MyArrayList<Integer> test = new MyArrayList<>();
        test.add(5);
        test.add(6);
        test.add(7);
        test.add(8);
        test.remove(7);

        assertTrue(!test.contains(7));
    }

    @Test
    public void setTest(){
        MyArrayList<String> test = new MyArrayList<>();
        test.add("abc");
        test.add("def");
        test.add("ghi");
        test.add("jkl");
        test.set(2,"mno");

        assertTrue(!test.contains("ghi"));
        assertTrue(test.contains("mno"));
    }
}
